//
// Copyright (C) 1993-1996 Id Software, Inc.
// Copyright (C) 2016-2017 Alexey Khokholov (Nuke.YKT)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// DESCRIPTION:
//	Created by a sound utility.
//	Kept as a sample, DOOM2 sounds.
//

#include "doomtype.h"
#include "sounds.h"
#include "options.h"

//
// Information about all the music
//

musicinfo_t S_music[] =
    {
        {0},
        {"E1M1", 0},
        {"E1M2", 0},
        {"E1M3", 0},
        {"E1M4", 0},
        {"E1M5", 0},
        {"E1M6", 0},
        {"E1M7", 0},
        {"E1M8", 0},
        {"E1M9", 0},
        {"E2M1", 0},
        {"E2M2", 0},
        {"E2M3", 0},
        {"E2M4", 0},
        {"E2M5", 0},
        {"E2M6", 0},
        {"E2M7", 0},
        {"E2M8", 0},
        {"E2M9", 0},
        {"E3M1", 0},
        {"E3M2", 0},
        {"E3M3", 0},
        {"E3M4", 0},
        {"E3M5", 0},
        {"E3M6", 0},
        {"E3M7", 0},
        {"E3M8", 0},
        {"E3M9", 0},
        {"INTER", 0},
        {"INTRO", 0},
        {"BUNNY", 0},
        {"VICTOR", 0},
        {"INTROA", 0},
        {"RUNNIN", 0},
        {"STALKS", 0},
        {"COUNTD", 0},
        {"BETWEE", 0},
        {"DOOM", 0},
        {"THE_DA", 0},
        {"SHAWN", 0},
        {"DDTBLU", 0},
        {"IN_CIT", 0},
        {"DEAD", 0},
        {"STLKS2", 0},
        {"THEDA2", 0},
        {"DOOM2", 0},
        {"DDTBL2", 0},
        {"RUNNI2", 0},
        {"DEAD2", 0},
        {"STLKS3", 0},
        {"ROMERO", 0},
        {"SHAWN2", 0},
        {"MESSAG", 0},
        {"COUNT2", 0},
        {"DDTBL3", 0},
        {"AMPIE", 0},
        {"THEDA3", 0},
        {"ADRIAN", 0},
        {"MESSG2", 0},
        {"ROMER2", 0},
        {"TENSE", 0},
        {"SHAWN3", 0},
        {"OPENIN", 0},
        {"EVIL", 0},
        {"ULTIMA", 0},
        {"READ_M", 0},
        {"DM2TTL", 0},
        {"DM2INT", 0}};

//
// Information about all the sfx
//

sfxinfo_t S_sfx[] =
    {
        // S_sfx[0] needs to be a dummy for odd reasons.
        {"NONE", false, 0, 0},
        {"PISTOL", false, 64, 0},
        {"SHOTGN", false, 64, 0},
        {"SGCOCK", false, 64, 0},
        {"DSHTGN", false, 64, 0},
        {"DBOPN", false, 64, 0},
        {"DBCLS", false, 64, 0},
        {"DBLOAD", false, 64, 0},
        {"PLASMA", false, 64, 0},
        {"BFG", false, 64, 0},
        {"SAWUP", false, 64, 0},
        {"SAWIDL", false, 118, 0},
        {"SAWFUL", false, 64, 0},
        {"SAWHIT", false, 64, 0},
        {"RLAUNC", false, 64, 0},
        {"RXPLOD", false, 70, 0},
        {"FIRSHT", false, 70, 0},
        {"FIRXPL", false, 70, 0},
        {"PSTART", false, 100, 0},
        {"PSTOP", false, 100, 0},
        {"DOROPN", false, 100, 0},
        {"DORCLS", false, 100, 0},
        {"STNMOV", false, 119, 0},
        {"SWTCHN", false, 78, 0},
        {"SWTCHX", false, 78, 0},
        {"PLPAIN", false, 96, 0},
        {"DMPAIN", false, 96, 0},
        {"POPAIN", false, 96, 0},
        {"VIPAIN", false, 96, 0},
        {"MNPAIN", false, 96, 0},
        {"PEPAIN", false, 96, 0},
        {"SLOP", false, 78, 0},
        {"ITEMUP", true, 78, 0},
        {"WPNUP", true, 78, 0},
        {"OOF", false, 96, 0},
        {"TELEPT", false, 32, 0},
        {"POSIT1", true, 98, 0},
        {"POSIT2", true, 98, 0},
        {"POSIT3", true, 98, 0},
        {"BGSIT1", true, 98, 0},
        {"BGSIT2", true, 98, 0},
        {"SGTSIT", true, 98, 0},
        {"CACSIT", true, 98, 0},
        {"BRSSIT", true, 94, 0},
        {"CYBSIT", true, 92, 0},
        {"SPISIT", true, 90, 0},
        {"BSPSIT", true, 90, 0},
        {"KNTSIT", true, 90, 0},
        {"VILSIT", true, 90, 0},
        {"MANSIT", true, 90, 0},
        {"PESIT", true, 90, 0},
        {"SKLATK", false, 70, 0},
        {"SGTATK", false, 70, 0},
        {"SKEPCH", false, 70, 0},
        {"VILATK", false, 70, 0},
        {"CLAW", false, 70, 0},
        {"SKESWG", false, 70, 0},
        {"PLDETH", false, 32, 0},
        {"PDIEHI", false, 32, 0},
        {"PODTH1", false, 70, 0},
        {"PODTH2", false, 70, 0},
        {"PODTH3", false, 70, 0},
        {"BGDTH1", false, 70, 0},
        {"BGDTH2", false, 70, 0},
        {"SGTDTH", false, 70, 0},
        {"CACDTH", false, 70, 0},
        {"BRSDTH", false, 32, 0},
        {"CYBDTH", false, 32, 0},
        {"SPIDTH", false, 32, 0},
        {"BSPDTH", false, 32, 0},
        {"VILDTH", false, 32, 0},
        {"KNTDTH", false, 32, 0},
        {"PEDTH", false, 32, 0},
        {"SKEDTH", false, 32, 0},
        {"POSACT", true, 120, 0},
        {"BGACT", true, 120, 0},
        {"DMACT", true, 120, 0},
        {"BSPACT", true, 100, 0},
        {"BSPWLK", true, 100, 0},
        {"VILACT", true, 100, 0},
        {"NOWAY", false, 78, 0},
        {"BAREXP", false, 60, 0},
        {"PUNCH", false, 64, 0},
        {"HOOF", false, 70, 0},
        {"METAL", false, 70, 0},
        {"CHGUN", false, 64, 0},
        {"BDOPN", false, 100, 0},
        {"BDCLS", false, 100, 0},
        {"FLAME", false, 32, 0},
        {"FLAMST", false, 32, 0},
        {"GETPOW", false, 60, 0},
        {"BOSPIT", false, 70, 0},
        {"BOSCUB", false, 70, 0},
        {"BOSSIT", false, 70, 0},
        {"BOSPN", false, 70, 0},
        {"BOSDTH", false, 70, 0},
        {"MANATK", false, 70, 0},
        {"MANDTH", false, 70, 0},
        {"SSSIT", false, 70, 0},
        {"SSDTH", false, 70, 0},
        {"KEENPN", false, 70, 0},
        {"KEENDT", false, 70, 0},
        {"SKEACT", false, 70, 0},
        {"SKESIT", false, 70, 0},
        {"SKEATK", false, 70, 0}};
